package edu.cmu.paid.authentication.test;

import java.io.*;
import java.lang.*;
import java.util.Random;
import edu.cmu.paid.authentication.crypto.*;
import edu.cmu.paid.authentication.util.*;

public class TestCaesar {
    public static void main(String [] args) {
        int TESTSIZE=10000;
	Random r=new Random();
	int size, i, j, shift;
	int count=0;
	byte [] cipher;
	byte [] clear;
	byte [] b;
	Caesar crypt = TestWrapper.constructCaesar();

	while (count < TESTSIZE) {
	    System.out.print(count+"\t");
	    size=r.nextInt();
	    size=size % TESTSIZE;
	    size=size>0? size: -size;
	    shift=r.nextInt();
	    b=new byte[size];
	    r.nextBytes(b);

	    cipher=crypt.encrypt(b, ByteConverterWrapper.toByteArray(shift));
	    clear=crypt.decrypt(cipher, ByteConverterWrapper.toByteArray(shift));

	    for (i=0;i<size-1;i++) {
		if (b[i]!=clear[i]) {
		    if ((new String(b)).charAt(i) == 0) {
			System.out.print("-");
			break;
		    }
		    System.out.println("Encryption wrong: " + i + ":" + size + " @ " + count + ".");
		    for (j=0;j<size;j++) {
			System.out.println("First Element: <" + (int) (new String(b)).charAt(j) + ">.");
		    }
		}
	    }

	    count++;
	}
    }
}
